#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

void *_lc_malloc(size_t size) {
	void *p;

	p = malloc(size);
	if(!p) {
		fprintf(stderr, "Memory allocation failed in libcost.\n");
		abort();
	}

	return p;
}

void *_lc_calloc(size_t nmemb, size_t size) {
	void *p;

	p = calloc(nmemb, size);
	if(!p) {
		fprintf(stderr, "Memory allocation failed in libcost.\n");
		abort();
	}

	return p;
}

void *_lc_realloc(void *ptr, size_t size) {
	void *p;

	p = realloc(ptr, size);
	if(!p) {
		fprintf(stderr, "Memory allocation failed in libcost.\n");
		abort();
	}

	return p;
}

char *_lc_strdup(char *str) {
	char *tmp;

#ifdef	HAVE_STRDUP

	if(!str)
		return NULL;

	tmp = strdup(str);
	if(!tmp) {
		fprintf(stderr, "Memory allocation failed in libcost.\n");
		abort();
	}

	return tmp;
#else
	int len;

	if(!str)
		return NULL;

	len = strlen(str) + 1;

	tmp = _lc_malloc(len);
	return memcpy(tmp, str, len)
#endif
}


