#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>

typedef struct {
	int a, b;
} numericrange;

#include "intern.h"
#include "cfgy.h"

extern char	*lc_cfg_i_cf;
extern char	*lc_cfg_i_cfpos;
extern off_t	lc_cfg_i_cfsize;
extern int	lc_cfg_i_nline;

int lc_cfg_i_brcount=0;

#define CHECKRANGE while(w-buf >= buflen) { int z=w-buf; w=(buf=(char *)_lc_realloc(buf, buflen=buflen << 1)) + z; };


char *lc_strndup(const char *from, int n) {
        char *p;
        if(n<0) n=0;
        p=(char *)_lc_malloc(n+1);
        memcpy(p, from, n);
        p[n]=0;
        return p;
}

int lccfglex() {
	int n;
	char *p;

	if(lc_cfg_i_cfpos - lc_cfg_i_cf > lc_cfg_i_cfsize) return 0;
	switch(*lc_cfg_i_cfpos) {
		case '\n':
			lc_cfg_i_nline++;
			break;
		case '#':
			lc_cfg_i_cfpos=index(lc_cfg_i_cfpos, '\n');
			if(!lc_cfg_i_cfpos) return 0; // End of file reached
			lc_cfg_i_nline++;
			break;
		case '{': lc_cfg_i_cfpos++; lc_cfg_i_brcount++; return LB;
		case '}': lc_cfg_i_cfpos++; lc_cfg_i_brcount--; return RB;
		case '=': lc_cfg_i_cfpos++; return EQ;
		case ',': lc_cfg_i_cfpos++; return COMMA;
		case ':': lc_cfg_i_cfpos++; return COLON;
		case ';': lc_cfg_i_cfpos++; return SEMICOLON;
		case '*':
			lc_cfg_i_cfpos++;
			return ALL;
		case '-':
			lc_cfg_i_cfpos++;
			return DASH;
		case '%':
			lc_cfg_i_cfpos++;
			return PERCENT;
		case '\'':
		case '"':
			{

/* === */

            char *buf=(char *)_lc_malloc(32);
	    int  buflen=32;
            char *w=buf;
            int insng=0;
            int indbl=0;

            p=lc_cfg_i_cfpos;

            while(1) {
            switch(*p) {
                case ' ':
                case '\t':
                case '\n':
                    lc_cfg_i_nline++;
                    if(insng || indbl) *w++=*p;
                    else if(w-buf) {
                        *w=0; lccfglval.tv_char=buf; return TOK_STRING;
                    }
                    break;
                case NULL:
                    if(w-buf) {
                        lc_cfg_i_cfpos=p;
                        *w=0; lccfglval.tv_char=buf; return TOK_STRING;
                    }
                    return 0;
                case '\'':
                    if(indbl) *w++=*p;
                    else insng=insng?0:1;
                    if(!insng && !indbl) {
                        lc_cfg_i_cfpos=p+1;
                        *w=0; lccfglval.tv_char=buf; return TOK_STRING;
                    }
                    break;
                case '"':
                    if(insng) *w++=*p;
                    else indbl=indbl?0:1;
                    if(!insng && !indbl) {
                        lc_cfg_i_cfpos=p+1;
                        *w=0; lccfglval.tv_char=buf; return TOK_STRING;
                    }
                    break;
                case '\\':
                    if(insng) { *w++=*p; break; }
                    p++;
			switch(*p) {
				case '\n': lc_cfg_i_nline++; break;
				case 'a': *w++='\a'; break;
				case 'b': w--; break;
				case 'e': *w++='\e'; break;
				case 'f': *w++='\f'; break;
				case 'n': *w++='\n'; break;
				case 'r': *w++='\r'; break;
				case 't': *w++='\t'; break;
				case 'v': *w++='\v'; break;
				case '\\': *w++='\\'; break;
				default: *w++=*p; break;
			}
                    break;
                default:
                    *w++=*p;
            }
                CHECKRANGE;
                p++;
            }

/* === */

			}
	};

	p = lc_cfg_i_cfpos;

	if((*p >= '0' && *p <= '9') || *p == '.') {
		n=strspn(p, "0123456789.");
		p=lc_strndup(p, n);
		lc_cfg_i_cfpos+=n;
		if(strchr(p, '.')) {
			lccfglval.tv_double=atof(p);
			free(p);
			return TOK_DOUBLE;
		};
		lccfglval.tv_int=atoi(p);
		free(p);
		return TOK_INT;
	};

	if((n=strspn(lc_cfg_i_cfpos, "-_!@abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890")) > 0) {
		int code=-1;

		p=lc_strndup(lc_cfg_i_cfpos, n);
		lc_cfg_i_cfpos+=n;

			if(!strcasecmp(p, "hour")) code=C_HOUR;
		else if(!strcasecmp(p, "hours")) code=C_HOUR;
		else if(!strcasecmp(p, "day")) code=C_DAY;
		else if(!strcasecmp(p, "days")) code=C_DAY;
		else if(!strcasecmp(p, "year")) code=C_YEAR;
		else if(!strcasecmp(p, "years")) code=C_YEAR;
		else if(!strcasecmp(p, "class")) code=C_CLASS;
		else if(!strcasecmp(p, "per")) code=C_PER;
		else if(!strcasecmp(p, "comment")) code=C_COMMENT;
		else if(!strcasecmp(p, "default")) code=C_DEFAULT;
		else if(!strncasecmp(p, "pref", 4)) code=C_PREF;

		else if(!strncasecmp(p, "Jan", 3))
			{ code=TOK_MONTH; lccfglval.tv_int=1; }
		else if(!strncasecmp(p, "Feb", 3))
			{ code=TOK_MONTH; lccfglval.tv_int=2; }
		else if(!strncasecmp(p, "Mar", 3))
			{ code=TOK_MONTH; lccfglval.tv_int=3; }
		else if(!strncasecmp(p, "Apr", 3))
			{ code=TOK_MONTH; lccfglval.tv_int=4; }
		else if(!strncasecmp(p, "May", 3))
			{ code=TOK_MONTH; lccfglval.tv_int=5; }
		else if(!strncasecmp(p, "Jun", 3))
			{ code=TOK_MONTH; lccfglval.tv_int=6; }
		else if(!strncasecmp(p, "Jul", 3))
			{ code=TOK_MONTH; lccfglval.tv_int=7; }
		else if(!strncasecmp(p, "Aug", 3))
			{ code=TOK_MONTH; lccfglval.tv_int=8; }
		else if(!strncasecmp(p, "Sep", 3))
			{ code=TOK_MONTH; lccfglval.tv_int=9; }
		else if(!strncasecmp(p, "Oct", 3))
			{ code=TOK_MONTH; lccfglval.tv_int=10; }
		else if(!strncasecmp(p, "Nov", 3))
			{ code=TOK_MONTH; lccfglval.tv_int=11; }
		else if(!strncasecmp(p, "Dec", 3))
			{ code=TOK_MONTH; lccfglval.tv_int=12; }

		else if(!strncasecmp(p, "Sun", 3))
			{ code=TOK_WDAY; lccfglval.tv_int=1; }
		else if(!strncasecmp(p, "Mon", 3))
			{ code=TOK_WDAY; lccfglval.tv_int=2; }
		else if(!strncasecmp(p, "Tue", 3))
			{ code=TOK_WDAY; lccfglval.tv_int=3; }
		else if(!strncasecmp(p, "Wed", 3))
			{ code=TOK_WDAY; lccfglval.tv_int=4; }
		else if(!strncasecmp(p, "Thu", 3))
			{ code=TOK_WDAY; lccfglval.tv_int=5; }
		else if(!strncasecmp(p, "Fri", 3))
			{ code=TOK_WDAY; lccfglval.tv_int=6; }
		else if(!strncasecmp(p, "Sat", 3))
			{ code=TOK_WDAY; lccfglval.tv_int=7; }

		if(code==-1) {
			lccfglval.tv_char=p;
			return TOK_STRING;
		} else {
			free(p);
			return code;
		};
	};

	lc_cfg_i_cfpos++;
	return lccfglex();
}
