#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include "cost.h"
#include "intern.h"

char *lc_cfg_i_cf;
char *lc_cfg_i_cfpos;
off_t	lc_cfg_i_cfsize;

int lccfgparse();

extern int lc_cfg_i_nline;
extern int lc_cfg_i_brcount;

int lc_qcompar(const void *a, const void *b) {
	return (*(lc_t_cfdata**)b)->specific - (*(lc_t_cfdata**)a)->specific;
};

void lc_end(void) {
	if(lc_cfdata) {
		lc_t_cfdata **cfdp, *cfd;
		for(cfdp = lc_cfdata; (cfd=*cfdp); cfdp++) {
			if(cfd->cls) free(cfd->cls);
			if(cfd->type) free(cfd->type);
			free(cfd);
		};
		free(lc_cfdata);
		lc_cfdata=NULL;
		lc_cfdsize=0;
	};

	if(lc_cpref) {
		char **c;
		for(c = lc_cpref; *c; c++);
			free(*c);
		free(lc_cpref);
		lc_cpref=NULL;
		_lc_f_maxch=0;
		_lc_f_donttoch=0;
	};
};

int lc_init(const char *cfname) {
	int fd;
	struct stat sb;

	if(!cfname)
		(char *)cfname="/usr/local/etc/cost.conf";

	if((fd=open(cfname, O_RDONLY)) == -1 || fstat(fd, &sb)) {
		fprintf(stderr, "-ERR: Can't open config file.\n");
		return -1;
	};

	if(sb.st_size <= 2) {
		fprintf(stderr, "-ERR: Invalid config file.\n");
		return -1;
	};

	lc_cfg_i_cfsize=sb.st_size+1;
	
	if(!(lc_cfg_i_cfpos=lc_cfg_i_cf=(char *)mmap(NULL, lc_cfg_i_cfsize, PROT_READ | PROT_WRITE, MAP_PRIVATE, fd, 0))) {
		close(fd);
		fprintf(stderr, "-ERR: Can't mmap() config file.\n");
		return -1;
	}

	lc_cfg_i_nline=0;
	lc_cfg_i_brcount=0;

	lccfgparse();

	close(fd);
	munmap(lc_cfg_i_cf, lc_cfg_i_cfsize);

	if(lc_cfdsize < 0 || !lc_cfdata || !*lc_cfdata) {
		fprintf(stderr, "Configuration file contains nothing.\n");
		return -1;
	};

	if(lc_cfdsize > 1)
	qsort(lc_cfdata, lc_cfdsize, sizeof(lc_t_cfdata*), lc_qcompar);

	return 0;
};


