#include <stdio.h>
#include <time.h>
#include <sys/time.h>
#include <stdlib.h>
#include "cost.h"

extern char **lc_cpref;

struct data {
	time_t time;
	unsigned int bytes;
};


int main() {
	double cost;
	struct data *datap;
	char *cls[] = {NULL, NULL, NULL};

	if(lc_init("./cost.conf")) {
		fprintf(stderr, "Can't read ./cost.conf.\n");
		exit(2);
	};

	cost=lc_timecost(time(NULL), 10000, "online", NULL);
	printf("lc_timecost(time(NULL), 10000, \"online\", NULL)"
		" = %f\n", cost);

	*cls = "Staff";
	cost=lc_timecost(time(NULL), 10000, "online", cls);
	printf("lc_timecost(time(NULL), 10000, \"online\", {\"Staff\", NULL})"
		" = %f\n", cost);

	*cls = "Customer";
	cost=lc_timecost(time(NULL), 10000, "online", cls);
	printf("lc_timecost(time(NULL), 10000, \"online\", {\"Customer\", NULL})"
		" = %f\n", cost);

	cls[0] = "Staff";
	cls[1] = "Customer";
	cost=lc_timecost(time(NULL), 10000, "online", cls);
	printf("lc_timecost(time(NULL), 10000, \"online\", {\"Staff\", \"Customer\", NULL})"
		" = %f\n", cost);

	datap=(struct data *)calloc(2, sizeof(struct data));
	datap->time=time(NULL);
	datap->bytes=20000;
	(datap+1)->time=time(NULL) + 4000;
	(datap+1)->bytes=30000;
	cost=lc_cost(datap, 2, sizeof(struct data),
		0, sizeof(time_t), sizeof(int), 0, "traffic", NULL);

	printf("lc_cost(datap, 2, sizeof(struct data), 0, sizeof(time_t),\n"
		"\tsizeof(int), 0, \"traffic\", NULL) = %f\n", cost);

	lc_end();

	return 0;
};
